from Products.Archetypes.public import *
from Products.ATSchemaEditorNG.SchemaEditor import SchemaEditor
from Products.ATSchemaEditorNG import util
from Products.CMFCore.utils import getToolByName
from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.PortalFolder import PortalFolder

import Products.GenericPloneContent.GenericPloneContent
from AccessControl import ClassSecurityInfo
from Products.CMFCore.CMFCorePermissions import ModifyPortalContent

class GenericContainer(SchemaEditor, BaseFolder):
    """
    Container to act as host for schema editing.
    """
    meta_type = portal_type = "Generic Container"
    schema = BaseSchema
    global_allow = 0
    actions = (
    {
    'id'           : 'view',
    'name'         : 'Edit schema',
    'action'       : 'string:${object_url}/gpc_editor',
    'permissions'   : (CMFCorePermissions.View, ),
    'category'      : 'object',
    },
    {'id':'edit','visible':None},
#    {},
    )
    
    def registerObjectSchema(self, class_name):
    	self.atse_registerObject( getattr(Products.GenericPloneContent.GenericPloneContent,class_name),
	filtered_schemas= ('metadata', ),
	undeleteable_fields=('file'))
  

    def automatic_value(self,**kw):
        return "method:automatic"

    security = ClassSecurityInfo()

    # Cataloging methods
    # ------------------

    security.declareProtected(ModifyPortalContent, 'indexObject')
    def indexObject(self):
        """
            Index the object in the portal catalog.
        """
        pass

    security.declareProtected(ModifyPortalContent, 'unindexObject')
    def unindexObject(self):
        """
            Unindex the object from the portal catalog.
        """
        pass

    security.declareProtected(ModifyPortalContent, 'reindexObject')
    def reindexObject(self, idxs=[]):
        """
            Reindex the object in the portal catalog.
            If idxs is present, only those indexes are reindexed.
            The metadata is always updated.

            Also update the modification date of the object,
            unless specific indexes were requested.
        """
        pass

    security.declareProtected(ModifyPortalContent, 'reindexObjectSecurity')
    def reindexObjectSecurity(self):
        """
            Reindex security-related indexes on the object
            (and its descendants).
        """
        pass

registerType(GenericContainer)

