
from AccessControl import ClassSecurityInfo
from Products.CMFCore.CMFCorePermissions import View
from Globals import InitializeClass
from Products.CMFCore.utils import getToolByName
import config
from Products.ATSchemaEditorNG.ParentManagedSchema import ParentManagedSchema
from Products.Archetypes.utils import  DisplayList



class GenericParentManagedSchema(ParentManagedSchema):
    """ mix-in class for AT content-types whose schema is managed by
        the parent container and retrieved through acquisition.
    """

    global_allow = 0
    security = ClassSecurityInfo()
    security.declareProtected(View, 'Schema')
    def Schema(self, schema_id=None):
        """ Retrieve schema from Generic Container object. The client class should
            override the method as Schema(self) and then call his method
            of the baseclass with the corresponding schema_id.
        """

        # Schema() seems to be called during the construction phase when there is
        # no acquisition context. So we return the default schema itself.
        if not hasattr(self, 'aq_parent'):
            if hasattr(self, 'schema'):
                return self._wrap_schema(self.schema)
            else:
                raise ValueError('Instance has no "schema" attribute defined')


	portal_schemamanager=getToolByName(self,'portal_schemamanager')	



 
	schema_type = getattr(self.aq_base, 'schema_type', self.getTypeInfo().id)
	if ( not hasattr(self.aq_base, 'schema_type')) and (not schema_type in portal_schemamanager.precreated_models):

	    self._v_schema = None
	    self.setSchemaType(schema_type)

	    



	generic_container=portal_schemamanager[schema_type]

        if not generic_container.atse_isSchemaRegistered(self.meta_type):
            return self._wrap_schema(self.schema)

        if not schema_id:
	    schema_id = self.meta_type


        self._v_schema = getattr(self, '_v_schema', None)

        if self._v_schema is None:

            # looking for changes in the schema hold by the object
            self._v_schema = self._lookupChanges(schema_id)

            if not hasattr(self, '_md'):
                self.initializeArchetype()

            for field in self._v_schema.fields():

                ##########################################################
                # Fake accessor and mutator methods
                ##########################################################

                name = field.getName()

                def atse_get_method(self=self, name=name, *args, **kw):
                    return self.getField(name).get(self, **kw)

                # workaround for buggy widget/keyword AT template that
                # uses field.accessor as catalog index name *grrrr*
                # XXX find another way to fix that
                if name != 'subject':
                    setattr(self, '_v_%s_accessor' % name, atse_get_method )
                    field.accessor = '_v_%s_accessor' % name
                    field.edit_accessor = field.accessor

                def atse_set_method(value, self=self, name=name, *args, **kw):
                    if name != 'id':
                        self.getField(name).set(self, value, **kw)

                    # saving id directly (avoiding unicode problems)
                    else: self.setId(value)

                setattr(self, '_v_%s_mutator' % name, atse_set_method )
                field.mutator = '_v_%s_mutator' % name

                # Check if we need to update our own properties
                try:
                    value = field.get(self)
                    
                except:
                    field.set(self, field.default)

        return self._wrap_schema(self._v_schema)

    def _lookupChanges(self, atse_schema_id):
        """ Checks if schema has changed """


	generic_container=getToolByName(self,'portal_schemamanager')[getattr(self.aq_base, 'schema_type',self.getTypeInfo().id)]
        return generic_container.atse_getSchemaById(atse_schema_id)

    def setSchemaType(self,schema_type):
	self.schema_type = schema_type

    def automatic_vocabulary(self,**kw):
	portal_type=self.aq_base.portal_type
	method_name='vocabulary_'+portal_type+'_'+kw['field'].getName()
	vocabulary_method=getattr(self,method_name,[])
	if vocabulary_method:
		vocabulary_method=vocabulary_method()
	#vocabulary_method = [ (str(item[0]),item[1])  for item in vocabulary_method]
    	return DisplayList(vocabulary_method)
	
    def automatic_default(self,**kw):
	#import pdb;pdb.set_trace()
        if not hasattr(self,'num'):
            setattr(self,'num',0)
	schema_type=self.aq_base.schema_type
        folder=getattr(self,'DefaultFields',None)
        method_name='default_'+schema_type.lower()+'_'+str(self.num/2)
        if not hasattr(folder,method_name):
            setattr(self,'num',0)
            method_name='default_'+schema_type.lower()+'_'+str(self.num/2)
        value=getattr(folder,method_name,'')
        setattr(self,'num',self.num+1)

        return value(self)

    def SearchableText(self):
        "Returns a concatanation of all searchable text"

        ret = ""
	for field in self.Schema().filterFields(isMetadata=0):
		val = field.get(self)
		if val:
			ret += str(val) + ' '

        return ret
	
InitializeClass(GenericParentManagedSchema)
