from Products.CMFCore.utils import UniqueObject
from Products.CMFCore.ActionProviderBase import ActionProviderBase
from OFS.Folder import Folder
from AccessControl import ClassSecurityInfo
from Products.Archetypes.public import BaseFolder
from Products.CMFDefault import SkinnedFolder
from Globals import InitializeClass
from Products.GenericPloneContent.config import *
from Products.CMFCore import permissions


import Products
if hasattr(Products,'PloneArticle_no'):
	plone_article_available = 1
else:
	plone_article_available = 0

if hasattr(Products,'PloneExFile_no'):
	plone_exfile_available = 1
else:
	plone_exfile_available = 0

# if hasattr(Products,'ATContentTypes'):
# 	atcontenttypes_available = 1
# else:
# 	atcontenttypes_available = 0
# 	


class SchemaManagerTool(UniqueObject, ActionProviderBase, Folder):
	"""This is a tool to manage the creation of new portal type with their own schema"""

	id = 'portal_schemamanager'
	meta_type = 'Schema Manager Tool'
	
	security = ClassSecurityInfo()
	
	
	plone_tool = 1
	models = GENERIC_MODELS

    
    
    
	if plone_article_available:
		models += ['Generic Article Content']
	if plone_exfile_available:
		models += ['Generic ExFile']
# 	if atcontenttypes_available:
# 		models += ['Generic Document',"Generic Event",
# 				"Generic File","Generic Favorite",
# 				"Generic Image","Generic Link",
# 				"Generic NewsItem","Generic Topic"]
	
	
	precreated_models=models
	fti_precreated_models={}
	for model in models:
		fti_precreated_models['GenericPloneContent: ' +model] = 'GenericPloneContent: ' +model.replace(' ', '')+' ('+model+')'
	
	storages = STORAGE_REGISTRY_INFO
	
	manage_options = (Folder.manage_options +
# 	 ({'label' : 'Overview', 'action' : 'manage_overview'},) +
			ActionProviderBase.manage_options 
			 )
	
	security.declareProtected(permissions.ManagePortal, 'addNewContent')
	def addNewContent(self,id,container_type_name):
		self.manage_addProduct['GenericPloneContent'].manage_addContent(id,container_type_name)



InitializeClass(SchemaManagerTool)
